
var currentFidelio;
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');

         document.addEventListener("backbutton", function(e){

                   navigator.app.exitApp();
            }, false);

        admob.createBannerView({publisherId: "ca-app-pub-4316571708135994/7293634504",isTesting: false});

    },
    serialConnect: function(){
bluetoothSerial.isConnected(
    function() {
        bluetoothSerial.disconnect(function(){
            bluetoothSerial.connect(currentFidelio, app.syncTime, 

                function(error){
                    console.log(error);
                    $("#error").html("<span class='verticalalign'>Could not connect to device. Are you connected to your devices via Bluetooth? Remember, you have to do this manually in the Android Settings Menu.</span>");
                    $("#error").show();
                    $("#success").hide();
                });
        });
    },
    function() {
        bluetoothSerial.connect(currentFidelio, app.syncTime, 

                function(error){
                    console.log(error);
                    $("#error").html("<span class='verticalalign'>Could not connect to device. Are you connected to your devices via Bluetooth? Remember, you have to do this manually in the Android Settings Menu.</span>");
                    $("#error").show();
                    $("#success").hide();
                });
    }
);
        
        console.log("connect initiated with "+currentFidelio);   

    },
    serialDisconnect: function(){
        bluetoothSerial.disconnect();
    },
    listDevices: function(){

bluetoothSerial.isEnabled(function(){

console.log("list devices");

        bluetoothSerial.list(function(devices){

            devices.forEach(function(device) {
                var regex = /PHILIPS*/gi; 
                if(match = regex.exec(device.name)){
                    currentFidelio = device.id;
                    $("#connected_device").html("<h2>"+device.name+"</h2>");
                    app.serialConnect();
                }
                $("#devices").append("<p class='paireddevices' data-id='"+device.id+"' data-name='"+device.name+"'>"+device.name+" - "+device.id+"</p>")
                console.log(device.id);
            });

            $("p.paireddevices").each(function(){
                if($(this).attr("data-name") == currentFidelio){

                    $(this).css("font-weight", "bold");

                }else{
                    $(this).css("font-weight", "normal");
                }
            });

            $("p.paireddevices").on("click", function(){
                currentFidelio = $(this).attr("data-id");
                $("#connected_device").html("<h2>"+$(this).attr("data-name")+"</h2>");
                app.serialConnect();
            })

        }, function(error){alert(error)});

}, 

function(){


    $("#connected_device").html("<span class='error'>Bluetooth is disabled. Please turn it on and connect to your Fidelio device.</span><br />");
    $("#syncbutton").css("background", "red");

}

);

    },
    syncTime: function() {

        bluetoothSerial.isConnected(function(){

        $("#error").html(" ");
        $("#error").hide();

        var now = new Date();
            var Jahr = now.getFullYear();
            Jahr = Jahr.toString();
            var year1 = Jahr.substr(0,2);
            var year2 = Jahr.substr(2,2);
            var month = ((now.getMonth())+1).toString();
            var day = (now.getDay());
            var hours = (now.getHours()).toString();
            var minutes = (now.getMinutes()).toString();
            var seconds = (now.getSeconds()).toString();

            console.log("Current Time: "+year1+year2+"-"+month+"-"+day+"-"+hours+":"+minutes+":"+seconds);


                    var data = new Uint8Array(13);
                    data[0] = 0x99;
                    data[1] = 0x0B;
                    data[2] = 0x87;
                    data[3] = 0x11;
                    data[4] = 0x08;
                    data[5] = year1.toString(16);
                    data[6] = year2.toString(16);
                    data[7] = month.toString(16);
                    data[8] = day.toString(16);
                    data[9] = hours.toString(16);
                    data[10] = minutes.toString(16);
                    data[11] = seconds.toString(16);
                    data[12] = 0x11;

                    bluetoothSerial.write(data, function(){
                        console.log("sync initiated");
                        $("#success").html("<span class='verticalalign'>Syncing complete.</span>")
                        $("#success").show();
                        $("#error").hide();
                        }, 

                        function(error){
                            console.log(error);
                            $("#error").html("<span class='verticalalign'>Error writing to device.</span>");
                            $("#error").show();
                            $("#success").hide();


                        });

                }, function(){

                    bluetoothSerial.serialConnect();
                    $("#error").html("<span class='verticalalign'>Connection not established. Please try again.</span>");
                    $("#error").show();
                    $("#success").hide();

                });

            
    },


    // Update DOM on a Received Event
    receivedEvent: function(id) {



        $("#syncbutton").click(function(){


            bluetoothSerial.isEnabled(function(){
            app.serialConnect();
            }, function(){
                $("#error").html("<span class='verticalalign'>Bluetooth is disabled</span>");
                $("#error").show();
                $("#success").hide();
            });

        });

        $("#listdevicesbutton").click(function(){
            $("#devices").show();
            $(this).hide();
        });

        $("#hidedevicesbutton").click(function(){

            $("#devices").hide();
            $("#listdevicesbutton").show();

        });

   

            app.listDevices();
        


    }
};

app.initialize();